var f = Object.defineProperty;
var b = (t, e, a) => e in t ? f(t, e, { enumerable: !0, configurable: !0, writable: !0, value: a }) : t[e] = a;
var c = (t, e, a) => (b(t, typeof e != "symbol" ? e + "" : e, a), a);
const x = (t, e) => {
  const a = t[e];
  return a ? typeof a == "function" ? a() : Promise.resolve(a) : new Promise((i, n) => {
    (typeof queueMicrotask == "function" ? queueMicrotask : setTimeout)(n.bind(null, new Error("Unknown variable dynamic import: " + e)));
  });
}, y = {
  num: {
    type: "num",
    match: /(\.e?|\b)\d(e-|[\d.oxa-fA-F_])*(\.|\b)/g
  },
  str: {
    type: "str",
    match: /(["'])(\\[^]|(?!\1)[^\r\n\\])*\1?/g
  },
  strDouble: {
    type: "str",
    match: /"((?!")[^\r\n\\]|\\[^])*"?/g
  }
};
class T {
  constructor() {
    c(this, "lastIndex", 0);
  }
  exec(e) {
    return null;
  }
}
const _ = [
  [
    "bash",
    [/#!(\/usr)?\/bin\/bash/g, 500],
    [/\b(if|elif|then|fi|echo)\b|\$/g, 10]
  ],
  ["html", [/<\/?[a-z-]+[^\n>]*>/g, 10], [/^\s+<!DOCTYPE\s+html/g, 500]],
  ["http", [/^(GET|HEAD|POST|PUT|DELETE|PATCH|HTTP)\b/g, 500]],
  [
    "js",
    [
      /\b(console|await|async|function|export|import|this|class|for|let|const|map|join|require)\b/g,
      10
    ]
  ],
  [
    "ts",
    [
      /\b(console|await|async|function|export|import|this|class|for|let|const|map|join|require|implements|interface|namespace)\b/g,
      10
    ]
  ],
  ["py", [/\b(def|print|class|and|or|lambda)\b/g, 10]],
  ["sql", [/\b(SELECT|INSERT|FROM)\b/g, 50]],
  ["pl", [/#!(\/usr)?\/bin\/perl/g, 500], [/\b(use|print)\b|\$/g, 10]],
  ["lua", [/#!(\/usr)?\/bin\/lua/g, 500]],
  [
    "make",
    [/\b(ifneq|endif|if|elif|then|fi|echo|.PHONY|^[a-z]+ ?:$)\b|\$/gm, 10]
  ],
  ["uri", [/https?:|mailto:|tel:|ftp:/g, 30]],
  ["css", [/^(@import|@page|@media|(\.|#)[a-z]+)/gm, 20]],
  ["diff", [/^[+><-]/gm, 10], [/^@@ ?[-+,0-9 ]+ ?@@/gm, 25]],
  ["md", [/^(>|\t\*|\t\d+.)/gm, 10], [/\[.*\](.*)/g, 10]],
  ["docker", [/^(FROM|ENTRYPOINT|RUN)/gm, 500]],
  ["xml", [/<\/?[a-z-]+[^\n>]*>/g, 10], [/^<\?xml/g, 500]],
  ["c", [/#include\b|\bprintf\s+\(/g, 100]],
  ["rs", [/^\s+(use|fn|mut|match)\b/gm, 100]],
  ["go", [/\b(func|fmt|package)\b/g, 100]],
  ["java", [/^import\s+java/gm, 500]],
  ["asm", [/^(section|global main|extern|\t(call|mov|ret))/gm, 100]]
];
function $(t) {
  var n;
  return ((n = _.map(([l, ...s]) => {
    const o = s.reduce(
      (g, [m, r]) => {
        var p;
        return g + (((p = t.match(new RegExp(m, "g"))) == null ? void 0 : p.length) || 0) * r;
      },
      0
    );
    return [l, o];
  }).filter(([l, s]) => s >= 20).sort(
    ([l, s], [o, g]) => g - s
  )[0]) == null ? void 0 : n[0]) || "plain";
}
const d = {
  show_title: !0,
  hide_line_numbers: !1,
  trim: !1
}, u = {};
function j(t) {
  var e, a, i, n;
  return (n = (a = (e = t.replaceAll("&", "&#38;")).replaceAll) == null ? void 0 : (i = a.call(e, "<", "&lt;")).replaceAll) == null ? void 0 : n.call(i, ">", "&gt;");
}
function v(t, e) {
  return e ? `<span class="shjs-syn-${e}">${t}</span>` : t;
}
async function h(t, e, a) {
  try {
    let i;
    typeof e == "string" ? i = await (u[e] ?? (u[e] = await x(/* @__PURE__ */ Object.assign({ "./languages/asm.ts": () => import("./asm-379ba160.js"), "./languages/bash.ts": () => import("./bash-015e7dec.js"), "./languages/bf.ts": () => import("./bf-aa15c0c7.js"), "./languages/c.ts": () => import("./c-af18f50b.js"), "./languages/css.ts": () => import("./css-e64ee7ce.js"), "./languages/csv.ts": () => import("./csv-76a588d2.js"), "./languages/diff.ts": () => import("./diff-aec35e8c.js"), "./languages/docker.ts": () => import("./docker-5097d762.js"), "./languages/git.ts": () => import("./git-8f4b3dae.js"), "./languages/go.ts": () => import("./go-021f6b4b.js"), "./languages/html.ts": () => import("./html-9b836012.js"), "./languages/http.ts": () => import("./http-df1e3b03.js"), "./languages/ini.ts": () => import("./ini-5d10b777.js"), "./languages/java.ts": () => import("./java-243f4a1b.js"), "./languages/js.ts": () => import("./js-6df0c4c6.js"), "./languages/js_template_literals.ts": () => import("./js_template_literals-66d1c0c4.js"), "./languages/jsdoc.ts": () => import("./jsdoc-ae526b45.js"), "./languages/json.ts": () => import("./json-09f5a37f.js"), "./languages/leanpub-md.ts": () => import("./leanpub-md-bcd028d8.js"), "./languages/log.ts": () => import("./log-555045a2.js"), "./languages/lua.ts": () => import("./lua-caf2eaa5.js"), "./languages/make.ts": () => import("./make-8539a036.js"), "./languages/md.ts": () => import("./md-f2cc006f.js"), "./languages/pl.ts": () => import("./pl-0721bfcf.js"), "./languages/plain.ts": () => import("./plain-bca357dc.js"), "./languages/py.ts": () => import("./py-dab73c47.js"), "./languages/regex.ts": () => import("./regex-9ed70c94.js"), "./languages/rs.ts": () => import("./rs-6068a719.js"), "./languages/sql.ts": () => import("./sql-40e76724.js"), "./languages/todo.ts": () => import("./todo-844da562.js"), "./languages/toml.ts": () => import("./toml-2817dc06.js"), "./languages/ts.ts": () => import("./ts-25a1f69e.js"), "./languages/uri.ts": () => import("./uri-89a58c02.js"), "./languages/xml.ts": () => import("./xml-ea692477.js"), "./languages/yaml.ts": () => import("./yaml-1ed06a89.js") }), `./languages/${e}.ts`))) : i = e;
    const n = Array.from(
      typeof e == "string" ? i.default : e.sub
    );
    let l, s = {
      index: null,
      match: "",
      end: 0,
      part: {}
    };
    const o = [];
    let g = 0, m;
    for (; g < t.length; ) {
      s.index = null;
      for (let r = n.length; r-- > 0; ) {
        if (l = n[r].expand ? y[n[r].expand] : n[r], o[r] === void 0 || o[r].match.index < g) {
          if (l.match.lastIndex = g, m = l.match.exec(t), m === null) {
            n.splice(r, 1), o.splice(r, 1);
            continue;
          }
          o[r] = { match: m, lastIndex: l.match.lastIndex };
        }
        o[r].match[0] && (s.index === null || o[r].match.index <= s.index) && (s = {
          part: l,
          index: o[r].match.index,
          match: o[r].match[0],
          end: o[r].lastIndex
        });
      }
      if (s.index === null)
        break;
      a(t.slice(g, s.index), i.type), g = s.end, s.part.sub ? await h(
        s.match,
        typeof s.part.sub == "string" ? s.part.sub : typeof s.part.sub == "function" ? s.part.sub(s.match) : s.part,
        a
      ) : a(s.match, s.part.type);
    }
    a(t.slice(g, t.length), i.type);
  } catch (i) {
    console.error(i);
  }
}
async function w(t, e, a = !0, i = d) {
  let n = "";
  return i.trim && (t = t.trim()), await h(
    t,
    e,
    (l, s) => n += v(j(l), s)
  ), a ? `<div><div class="shjs-numbers">${"<div></div>".repeat(
    i.hide_line_numbers ? 0 : t.split(`
`).length
  )}</div><div>${n}</div></div>` : n;
}
async function L(t, e = ((n) => (n = t.className.match(/shj-lang-([\w-]+)/)) == null ? void 0 : n[1])(), a, i = d) {
  let l = t.textContent;
  l !== null && (a ?? (a = `${t.tagName == "CODE" ? "in" : l.split(`
`).length < 2 ? "one" : "multi"}line`), t.dataset.lang = e, t.className = `${Array.from(t.classList).filter(
    (s) => !s.startsWith("shjs-") || s.startsWith("shjs-mode-")
  ).join(" ")}shjs-lang-${e} shjs-${a}`, i.show_title && t.classList.add("shjs-title"), t.innerHTML = await w(l, e, a === "multiline", i));
}
export {
  T as CustomRegex,
  d as default_options,
  $ as detect_language,
  L as highlight_element,
  w as highlight_text,
  u as languages,
  j as sanitize,
  v as to_span,
  h as tokenize
};
